/*
** Copyright (C) 1993-2013 Mark B. Hanson (mbh@panix.com)
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

static const char *const file_id =
	"@(#)$Id: tthing.C 1344 2013-04-05 21:18:39Z mark $";

#include "global.h"

#include "trig.h"
#include "util.h"

#include "tthing.h"

using namespace Trig;


Tthing::Tthing(void)
{
    //fprintf(stderr, "Tthing::Tthing()\n");
    theta = dtheta = 0.0;
} // Tthing::Tthing


Tthing::~Tthing(void)
{
    //fprintf(stderr, "Tthing::~Tthing()\n");
} // Tthing::~Tthing


void
Tthing::turn(void)
{
    theta = normalize(theta + dtheta);
} // Tthing::turn


void
Tthing::set_xpoints(void)
{
    const float sine = xsin(theta);
    const float cosine = xcos(theta);

    for (int i = 0; i < num_points; i++) {
	const float tx = size * points[i].x;
	const float ty = size * points[i].y;

	xpoints[i].x = (int)((tx * cosine) + (ty * sine) + x);
	xpoints[i].y = (int)(-(tx * sine) + (ty * cosine) + y);
    }
} // Tthing::set_xpoints
